<script lang="ts" setup>
import { ref } from 'vue';
import type { LicenseTermTitle } from '../utils/schema/license';

const props = defineProps<{
  selectedObligations?: LicenseTermTitle[];
  selectedPermissions?: LicenseTermTitle[];
  selectedProhibitions?: LicenseTermTitle[];
}>();

const emit = defineEmits<{
  (e: 'update:selectedObligations', value: LicenseTermTitle[]): void;
  (e: 'update:selectedPermissions', value: LicenseTermTitle[]): void;
  (e: 'update:selectedProhibitions', value: LicenseTermTitle[]): void;
}>();

const { selectedObligations, selectedPermissions, selectedProhibitions } =
  useVModels(props, emit, { passive: true, defaultValue: [] });

interface Options {
  id: LicenseTermTitle;
  label: string;
}

// todo: use props to set these options
const obligationOptions = ref<Options[]>([
  { id: 'LesserCopyleft', label: 'Lesser Copyleft' },
  { id: 'Attribution', label: 'Attribution' },
  { id: 'ShareAlike', label: 'Sharealike' },
  { id: 'Notice', label: 'Notice' },
  { id: 'Copyleft', label: 'Copyleft' },
  { id: 'StateChanges', label: 'State Changes' },
]);

const permissionOptions = ref<Options[]>([
  { id: 'Reproduction', label: 'Reproduction' },
  { id: 'DerivativeWorks', label: 'Derivative Works' },
  { id: 'Distribution', label: 'Distribution' },
  { id: 'Sublicensing', label: 'Sublicensing' },
  { id: 'PatentGrant', label: 'Use Patent Claims' },
]);

const prohibitionOptions = ref<Options[]>([
  { id: 'CommercialUse', label: 'Commercial Use' },
]);
</script>

<template>
  <div>
    <EcSelect
      v-model="selectedObligations"
      name="obligation"
      title="Obligation"
      :options="obligationOptions"
    ></EcSelect>
    <EcSelect
      v-model="selectedPermissions"
      name="permission"
      title="Permission"
      :options="permissionOptions"
    ></EcSelect>
    <EcSelect
      v-model="selectedProhibitions"
      name="prohibition"
      title="Prohibition"
      :options="prohibitionOptions"
    ></EcSelect>
  </div>
</template>
